<?php

function CreateEditSequence($in, $out)
{
  $result = Array();
  // Ignore that which is common to both
  while(count($in) > 0 && count($out) > 0
     && $in[0] == $out[0])
  {
    array_shift($in);
    array_shift($out);
  }

  $common_length          = 0;
  $common_begin_in_input  = 0;
  $common_begin_in_output = 0;
/*
  $aa = count($in);
  $bb = count($out);
  for($a=0; $a<$aa; ++$a)
    for($b=0; $b<$bb; ++$b)
    {
      for($c=0; $a+$c < count($in) && $b+$c < count($out); ++$c)
        if($in[$a+$c] != $out[$b+$c]) break;
      if($c > $common_length)
      {
        $common_length          = $c;
        $common_begin_in_input  = $a;
        $common_begin_in_output = $b;
      }
    }
*/
  $newout = Array();

  $trash_after_common  = count($in) - ($common_begin_in_input + $common_length);
  while($trash_after_common > 0)
  {
    $newout[] = 8;
    array_pop($in);
    --$trash_after_common;
  }
  if($common_begin_in_input > 0)
  {
    for($c=0; $c<$common_length; ++$c)
      $newout[] = 19; // go left
    while($common_begin_in_input > 0)
    {
      --$common_begin_in_input;
      array_shift($in);
      $newout[] = 8; // delete character on the left
    }
  }
  while($common_length > 0)
  {
    array_shift($out);
    $newout[] = 4; // go right
    --$common_length;
  }
  foreach($out as $c)
    $newout[] = $c; // add character
  return $newout;
  // Borland C++ editing keys:
  //   Backspace: 8 (^H)
  //   Left:      19 (^S)
  //   Right:     4 (^D)
  //   Delete:    7 (^G)
}

function GenChar($c)
{
  if($c == 39 || $c == 92) return $c;
  if($c >= 32 && $c < 126) return "'" . chr($c) . "'";
  return $c;
}

function RunCaseGen($casegen_script)
{
  $options = Array();
  $default = null;
  foreach(explode("\n", $casegen_script) as $line)
  {
    if(preg_match('/^([^ ]+) +([^ ]+)$/', $line, $mat))
    {
      if(!isset($default))
        $default = $mat[1];
      else
      {
        $options[$mat[1]] = $mat[2];
      }
    }
  }
  
  if(count($options) <= 1)
    return `echo '$casegen_script' | ./casegen-x86`;

  ksort($options);
  $n = count($options);
  $result = "\tcall BinarySearchLo\n"
          . "\tdb $n\n"
          . "\tdw $default\n"  ;
  $c=0;
  foreach($options as $k => $v)
  {
    $result .= $c++ ? ', ' : "\tdb ";
    $result .= GenChar($k);
  }
  $result .= "\n";
  $c=0;
  foreach($options as $k => $v)
  {
    $result .= $c++ ? ', ' : "\tdw ";
    $result .= $v;
    $dummies[$v] = true;
  }
  $result .= "\n";
  return $result;
}


$m = 94*83;
$w = 94;

$trans = Array
(
  0x82CD=>'HA',0x82F0=>'WO',  // WA,WO
  0x82B5=>'SI',
  0x82E9=>'RU',0x82C4=>'TE',
  0x82A9=>'KA',
  0x82DC=>'MA',0x82B7=>'SU', // DADIDUDEDO
  0x82C6=>'TO',0x82CC=>'NO',
  0x82B3=>'SA',0x82BB=>'SO',
  0x82E3=>'yu', // small YU
  0x82E5=>'yo', // small YO
  0x82E1=>'ya', // small YA
  0x82A0=>'A', // A
  0x82A4=>'U',
  0x82A6=>'E', // E
  0x82A8=>'O', // O
  0x815B=>'-', // long voice mark
  0x82CA=>'NU',0x82D9=>'HO',
  0x82E6=>'YO', // YO
  0x82AB=>'KI',0x82AD=>'KU',0x82AF=>'KE',0x82B1=>'KO', // KAKIKUKEKO
  0x82C7=>'DO',
  0x82B9=>'SE', // SASISUSESO
  0x82BD=>'TA',0x82BF=>'TI',0x82C2=>'TU', // TATITUTETO
  0x82C5=>'DE',0x82BE=>'DA',/*0x82C0=>'DI',0x82C3=>'DU',*/
  0x82C8=>'NA',0x82C9=>'NI',0x82CB=>'NE', // NANINUNENO
  0x82D0=>'HI',0x82D3=>'HU',0x82D6=>'HE', // HAHIHUHEHO
  0x82CE=>'BA',
  0x82DF=>'ME',
  0x82DD=>'MI',0x82DE=>'MU',0x82E0=>'MO', // MAMIMUMEMO
  0x82ED=>'WA',
  0x82E2=>'YA', // YA
  0x82E4=>'YU', // YU
  
  0x82E7=>'RA',
  /*0x82B4=>'ZA',*/0x82B6=>'ZI',/*0x82B8=>'ZU',0x82BA=>'ZE',0x82BC=>'ZO',*/ // ZAZIZUZEZO
  0x82E8=>'RI',0x82EA=>'RE',0x82EB=>'RO', // RARIRURERO
  0x82AA=>'GA',/*0x82AC=>'GI',0x82AE=>'GU',0x82B0=>'GE',*/0x82B2=>'GO', // GAGIGUGEGO
  /*0x82D1=>'BI',0x82D4=>'BU',0x82D7=>'BE',0x82DA=>'BO',*/ // BABIBUBEBO
  /*0x82CF=>'PA',0x82D2,0x82D5,0x82D8,0x82DB=>'PO',*/ // PAPIPUPEPO
  0x82A2=>'I', // I
  0x82F1=>'N',
  0x82C1=>'tu', // small tsu
  0x814A=>'"', // dakuten
  0x814B=>'', // handakuten
  0x8141=>',', 0x8142=>'.', // comma, full stop
  /*0x829F=>'a',*/ // small A
  /*0x82A3=>'u',*/ // small U
  0x82A5=>'e', // small E
  0x82A1=>'i', // small I
  /*0x82A7=>'o',*/ // small O
);

$m = count($trans);
$w = 16;

$im = ImageCreate(9*16, 16*16);
$bg = ImageColorAllocate($im, 0,0,0);
$fg = ImageColorAllocate($im, 255,255,255);
$pg = ImageColorAllocate($im, 0,0,192);

$freeslots = Array();

for($q=0; $q<32; ++$q)
{
  $p = $q ^ 16;
  if($p != 0x19 && $p != 0x1A
  && $p != 0x1C && $p != 0x1F
  && $p != 0x00 && $p != 0x03
  && $p != 0x04
  && $p != 0x0D && $p != 0x09 && $p != 0x08)
  {
    $freeslots[0xC0+$p] = 0xC0+$p;
    $freeslots[0x80+$q] = 0x80+$q;
  }
}

for($p=0x80; $p<=0xFF; ++$p)
{
  $nope = false;
  switch($p)
  {
    case 0xB1:case 0xB0: // scrollbar
    case 0xC0: // angle U,R
    case 0xBF: // angle L,D
    case 0xC4: // angle L,R
    case 0xB3: // angle U,D
    case 0xD9: // angle U,L
    case 0xDA: // angle R,D
    case 0xC3: case 0xB4: // horiz intersection (used in menu)
    case 0xBA: case 0xBB: /*case 0xBC:*/ // dangle
    case 0xCD: case 0xC9: case 0xC8: // dangle
    case 0xFE: // square
    case 0xDF: case 0xDC: // half blocks
      $nope = true;
  }
  if(!$nope) $freeslots[$p] = $p;
}

#$freeslots[0x02] = 0x02;
#$freeslots[0x15] = 0x15; not supported by qb
$freeslots[0x1C] = 0x1C;
$freeslots[0x1D] = 0x1D;
$freeslots[0x1E] = 0x1E;
$freeslots[0x1F] = 0x1F;

$ibmfont = file_get_contents('cp850.dat');
$done = Array();
for($chno=0; $chno<256; ++$chno)
  for($p=$chno*16; $p<($chno+1)*16; ++$p)
  {
    $y = $p%16 + 16*(int)($chno / 16);
    $x0 = 9*($chno%16);
    if(isset($freeslots[$chno]))
    {
      ImageLine($im, $x0,$y, $x0+7,$y, $pg);
      continue;
    }
    if($p==$chno*16)
      $done[ substr($ibmfont, $p, 16) ] = (int)($p/16);

    for($x=0; $x<8; ++$x)
      if(ord($ibmfont[$p]) & (128>>$x))
        ImageSetPixel($im, $x0+$x, $y, $fg);
  }

reset($freeslots);
$chc      = 0;
$fontdata = file_get_contents('kdp16sj.fnt');
$nch = 0;
$revtrans = Array();
$redefinedmap = Array();
foreach($trans as $ch => $name)
{
  $length = 2;
  if($ch == 0x814A || $ch == 0x814B)
  {
    $length = 1; // dakuten&handakuten are narrow
  }

  #$ch -= 0x8140; // convert sjis to font index
  $b1 = $ch >> 8;
  $b2 = ($ch & 0xFF);
  $ch = ($b1-0x81) * 187 + ($b2 - 0x40);
  #print "$ch ";

  for($half = 0; $half < $length; ++$half)
  {
    $halfstr = '';
    for($y=0; $y<16; ++$y)
      $halfstr .= @$fontdata[$ch*32+$y*2+$half];
    if(isset($done[$halfstr]))
    {
      $revtrans[$name][] = $done[$halfstr];
      continue;
    }

    list($chc,$dummy) = each($freeslots);
    if(!$chc) print "Shortage\n";
    
    $revtrans[$name][] = $chc;
    $done[$halfstr] = $chc;

    $ibmfont = substr($ibmfont, 0, $chc*16)
             . $halfstr
             . substr($ibmfont, ($chc+1)*16);

    $redefinedmap[$chc] = true;
    $yp = (int)($chc/$w) * 16;
    $xp = (int)($chc%$w) * 9;
    for($y=0; $y<16; ++$y)
    {
      $c = @ord($halfstr[$y]);
      for($x=0; $x<8; ++$x)
        if($c & (128>>$x))
        {
          ImageSetPixel($im, $xp+$x, $yp+$y, $fg);
          if($x == 7 && $chc >= 0xC0  && $chc <= 0xDF)
            ImageSetPixel($im, $xp+$x+1, $yp+$y, $fg);
        }
    }
    ++$nch;
  }
}
#print "\n\nDone, total $nch 8x16 characters\n";

ImagePng($im, 'ibmjp.png', 9);
#return;

#file_put_contents('ibmjp.fnt', $ibmfont);

for($c=ord('A'); $c<=ord('Z'); ++$c)
  if(!isset($revtrans[chr($c)]))
    $revtrans[chr($c)] = Array($c);
for($c=ord('a'); $c<=ord('z'); ++$c)
  if(!isset($revtrans[chr($c)]))
    $revtrans[chr($c)] = Array($c);

// Compose those dakuten/handakuten syllables that don't have dedicated glyphs.
foreach(Array('G'=>'K','Z'=>'S','D'=>'T','B'=>'H','P'=>'H') as $softc => $basec)
  foreach(Array('A','I','U','E','O') as $v)
  {
    $sy = $softc . $v;
    if(!isset($revtrans[$sy]))
    {
      $replacement = $revtrans[$basec.$v];
      $dakuten = $softc=='P' ? '' : '"';
      foreach($revtrans[$dakuten] as $k)
        $replacement[] = $k;
      $revtrans[$sy] = $replacement;
    }
  }

$inputs = Array
(
  'ka' => 'KA', 'kya' => 'KI|ya', 'ki' => 'KI', 'ko' => 'KO', 'kyo' => 'KI|yo', 'ku' => 'KU', 'kyu' => 'KI|yu', 'ke' => 'KE',
  'ga' => 'GA', 'gya' => 'GI|ya', 'gi' => 'GI', 'go' => 'GO', 'gyo' => 'GI|yo', 'gu' => 'GU', 'gyu' => 'GI|yu', 'ge' => 'GE',
  'sa' => 'SA', 'sya' => 'SI|ya', 'si' => 'SI', 'so' => 'SO', 'syo' => 'SI|yo', 'su' => 'SU', 'syu' => 'SI|yu', 'se' => 'SE',
  'za' => 'ZA', 'zya' => 'ZI|ya', 'zi' => 'ZI', 'zo' => 'ZO', 'zyo' => 'ZI|yo', 'zu' => 'ZU', 'zyu' => 'ZI|yu', 'ze' => 'ZE',
  'sha' => 'SI|ya', 'shi' => 'SI', 'sho' => 'SI|yo', 'shu' => 'SI|yu', 'she' => 'SI|e',
  'sya' => 'SI|ya', 'syi' => 'SI', 'syo' => 'SI|yo', 'syu' => 'SI|yu',
  'swe' => 'SU|e', 'swi' => 'SU|i',
  'ja'  => 'ZI|ya', 'ji'  => 'ZI', 'jo'  => 'ZI|yo', 'ju'  => 'ZI|yu', 'je' => 'ZI|e',
  'ha' => 'HA', 'hya' => 'HI|ya', 'hi' => 'HI', 'ho' => 'HO', 'hyo' => 'HI|yo', 'hu' => 'HU', 'hyu' => 'HI|yu', 'he' => 'HE',
  'fya' => 'HU|ya', 'fyo' => 'HU|yo', 'fu' => 'HU', 'fyu' => 'HU|yu',
  'fi' => 'HU|i', 'fwi' => 'HU|i',
  'fe' => 'HU|e', 'fwe' => 'HU|e',  
  'ba' => 'BA', 'bya' => 'BI|ya', 'bi' => 'BI', 'bo' => 'BO', 'byo' => 'BI|yo', 'bu' => 'BU', 'byu' => 'BI|yu', 'be' => 'BE',
  'pa' => 'PA', 'pya' => 'PI|ya', 'pi' => 'PI', 'po' => 'PO', 'pyo' => 'PI|yo', 'pu' => 'PU', 'pyu' => 'PI|yu', 'pe' => 'PE',
  'ta' => 'TA', 'tya' => 'TI|ya', 'ti' => 'TI', 'to' => 'TO', 'tyo' => 'TI|yo', 'tu' => 'TU', 'tyu' => 'TI|yu', 'te' => 'TE',
  'da' => 'DA', 'dya' => 'DI|ya', 'di' => 'DI', 'do' => 'DO', 'dyo' => 'DI|yo', 'du' => 'DU', 'dyu' => 'DI|yu', 'de' => 'DE',
  'dza' => 'DU|ya', 'dzi' => 'DU|i', 'dzu' => 'DU', 'dze' => 'DU|e', 'dzo' => 'DU|yo',
  'tsa' => 'TU|ya', 'tsu' => 'TU', 'tso' => 'TU|yo', 'tse' => 'TU|e', 'tsi' => 'TU|i',
  'cha' => 'TI|ya', 'chi' => 'TI', 'chu' => 'TI|yu', 'cho' => 'TI|yo', 'che' => 'TI|e',
  'tya' => 'TI|ya', 'tyi' => 'TI', 'tyu' => 'TI|yu', 'tyo' => 'TI|yo',
  'tha' => 'TE|ya', 'thu' => 'TE|yu', 'tho' => 'TE|yo',
  'twe' => 'TO|e', 'twi' => 'TO|i',
  'ma' => 'MA', 'mya' => 'MI|ya', 'mi' => 'MI', 'mo' => 'MO', 'myo' => 'MI|yo', 'mu' => 'MU', 'myu' => 'MI|yu', 'me' => 'ME',
  'ra' => 'RA', 'rya' => 'RI|ya', 'ri' => 'RI', 'ro' => 'RO', 'ryo' => 'RI|yo', 'ru' => 'RU', 'ryu' => 'RI|yu', 're' => 'RE',
  'la' => 'RA', 'lya' => 'RI|ya', 'li' => 'RI', 'lo' => 'RO', 'lyo' => 'RI|yo', 'lu' => 'RU', 'lyu' => 'RI|yu', 'le' => 'RE',
  'na' => 'NA', 'nya' => 'NI|ya', 'ni' => 'NI', 'no' => 'NO', 'nyo' => 'NI|yo', 'nu' => 'NU', 'nyu' => 'NI|yu', 'ne' => 'NE',
  'nn' => 'N',
  'nk' => 'N|k',
  'ng' => 'N|g',
  'ns' => 'N|s', 
  'nz' => 'N|z',
  'nj' => 'N|j',
  'nh' => 'N|h',
  'nb' => 'N|b', 'mb' => 'N|b',
  'np' => 'N|p', 'mp' => 'N|p',
  'nt' => 'N|t',
  'nd' => 'N|d',
  'nm' => 'N|m', 'mm' => 'N|m',
  'nr' => 'N|r', 'nl' => 'N|l',
  'nw' => 'N|w', 'nv' => 'N|v', 'nf' => 'N|f',
  'b' => 'b', 'c' => 'c', 'd' => 'd', 'f' => 'f', 'g' => 'g', 'h' => 'h', 'j' => 'j',
  'k' => 'k', 'm' => 'm', 'n' => 'n', 'p' => 'p', 'r' => 'r', 's' => 's', 'l' => 'l',
  't' => 't', 'w' => 'w', 'x' => 'x', 'y' => 'y', 'z' => 'z', 'v' => 'v',
  'a' => 'A',  'i' => 'I', 'o' => 'O', 'u' => 'U', 'e' => 'E', 'o' => 'O',
  'ya' => 'YA', 'yo' => 'YO', 'yu' => 'YU', 'wa' => 'WA', 'wo' => 'WO',
  'xtu' => 'tu', 'xya' => 'ya', 'xyo' => 'yo', 'xyu' => 'yu',
  'kk' => 'tu|k', 'gg' => 'tu|g', 'ss' => 'tu|s', 'zz' => 'tu|z', 'jj' => 'tu|j',
  'hh' => 'tu|h', 'bb' => 'tu|b', 'pp' => 'tu|p', 'tt' => 'tu|t', 'dd' => 'tu|d',
  'rr' => 'tu|r', 'ww' => 'tu|w', 'll' => 'tu|l', 'yy' => 'tu|y',
  'cc' => 'tu|c', 'tc' => 'tu|c', 'ff' => 'tu|f', 'vv' => 'tu|v',
  '-' => '-',
  '.' => '.',
  ',' => ',',
  'xe' => 'e', 'xi' => 'i',
  'we' => 'U|e', 'wi' => 'U|i',
  'vya' => 'U|"|ya', 've' => 'U|"|e', 'vi' => 'U|"|i', 'vyo' => 'U|"|yo', 'vyu' => 'U|"|yu', 'vu' => 'U|"'
);

$backspace = '<';

foreach($inputs as $input => $outcome)
{
  $cut = substr($input, 0, -1);
  $shortened = '';
  while(strlen($cut) > 0)
  {
    if(isset($inputs[$cut]))
    {
      $shortened = $inputs[$cut] . '|' . $shortened;
      break;
    }
    $lastch = substr($cut, -1);
    $shortened = $inputs[$lastch] . '|' . $shortened;
    $cut = substr($cut, 0, -1);
  }
  while(substr($shortened, -1) == '|')
    $shortened = substr($shortened, 0, -1);
  $inputs[$input . $backspace] = $shortened;
}

$combined_inputs = Array();
foreach($inputs as $input1 => $outcome1)
  foreach($inputs as $input2 => $outcome2)
  {
    if(preg_match("/$backspace/", $input1.$input2)) continue;
    if(!isset($inputs[$input1.$input2]))
    {
      $out_characters = Array();
      foreach(explode('|', "$outcome1|$outcome2") as $c)
        foreach($revtrans[$c] as $c1)
          $out_characters[] = $c1;
      $combined_inputs[$input1.$input2] = $out_characters;
    }
  }

ksort($inputs);

$revtrans_debug = Array();
foreach($revtrans as $name => $components)
  $revtrans_debug[$name] = join(',', $components);
#print_r($revtrans_debug);

$trivial = Array();
foreach($inputs as $input => $outcome)
{
  if(!empty($outcome))
    $outcome = explode('|', $outcome);
  else
    $outcome = Array();

  $cut = substr($input, 0, -1);
  $in_characters = Array();
  if(isset($inputs[$cut]))
    $in_characters = $inputs[$cut][1];
  elseif(isset($combined_inputs[$cut]))
    $in_characters = $combined_inputs[$cut];

  $out_characters = Array();
  foreach($outcome as $c)
    foreach($revtrans[$c] as $c1)
      $out_characters[] = $c1;
  $inputs[$input] = Array($in_characters, $out_characters);

  $trivial_income  = Array();
  $trivial_outcome = Array();
  $b = strlen($input);
  for($a=0; $a<$b; ++$a)
  {
    if($input[$a] == $backspace)
      array_pop($trivial_outcome);
    else
    {
      $trivial_outcome[] = ord($input[$a]);
      if($a+1 < $b)
        $trivial_income[] = ord($input[$a]);
    }
  }

  if($in_characters === $trivial_income
  && $out_characters === $trivial_outcome)
    $trivial[$input] = $input;
}
foreach($trivial as $input)
  unset($inputs[$input]);

$input_debug = Array();
foreach($inputs as $input => $situation)
  $input_debug[$input] = join(',', $situation[0]). ' -> '.join(',', $situation[1]);
#print_r($input_debug);

// Create context-dependent IME keymap
$key_translations = Array();
foreach($inputs as $input => $situation)
{
  $last_key = substr($input, -1);
  
  $in  = $situation[0];
  $out = $situation[1];

  $s = &$key_translations[$last_key][ join(',', $in) ];

  #if(isset($s))
  #  print "AMBIGUOUS HISTORY $input: $last_key: ".join(',',$in)."\n";
  
  $out = CreateEditSequence($in, $out);
  $s = join(',', $out);
  unset($s);
}

#// Add explicit default:
#foreach($key_translations as $k=>&$v)
#{
#  ksort($v);
#  $c = ord($k); if($k==$backspace) $c = 8;
#  if(!isset($v[''])) $v[''] = (string)$c;
#}

unset($v);
ksort($key_translations);

#print_r($key_translations);

// Convert to assembler language
$outcomes = Array();
foreach($key_translations as $input => &$history_choices)
  foreach($history_choices as $history => &$outcome)
    if(isset($outcomes[$outcome]))
      $outcome = $outcomes[$outcome];
    else
      $outcome = $outcomes[$outcome] = sprintf('ks%03u',count($outcomes));
unset($outcome);
unset($history_choices);

uksort($outcomes, function($a,$b)
                  {
                    return strlen($b)-strlen($a);
                  });
$outcomes_str = "\n\n";
foreach($outcomes as $k=>$v)
{
  $k .= ",0\n";
  /*$p = strpos($outcomes_str, ",$k");
  if($p === false)*/
    $outcomes_str .= "$v:\tcall PutSequence\n\tdb $k";
  /*else
  {
    $outcomes_str = substr($outcomes_str, 0, $p)
                  . "\n$v:\tdb $k"
                  . substr($outcomes_str, $p+strlen(",$k"));
  }*/
}

$counter = 0;
$input_casegen_script = "DefaultInput $counter\n"; ++$counter;

$history_test_str = '';
foreach($key_translations as $input => $history_choices)
{
  $c = $input == $backspace ? 8 : ord($input);

  $input_label = 't';
  if($c >= 97 && $c <= 122)
    $input_label .= '_'.chr($c);
  else
    $input_label .= '_'.$c;

  $pfx = Array();
  #print_r($history_choices);
  foreach($history_choices as $history => $outcome)
  {
    $seq = $input_label;
    $prev = &$pfx[$seq];
    if($history != '')
      foreach(array_reverse(explode(',', $history)) as $o)
      {
        if((int)$o >= 97 && (int)$o <= 122)
          $seq .= '_'.chr((int)$o);
        else
          $seq .= '_'.$o;

        $prev[$o] = $seq;
        $prev = &$pfx[$seq];
      }
    $prev[''] = $outcome;
    unset($prev);
  }
  #print_r($pfx);
  
  $direct_jump = Array();
  foreach($pfx as $seq => $choices)
  {
    $default = 'DefaultInput';
    $casegen_script = '';
    foreach($choices as $k=>$v)
      if($k == '')
        $default = $v;
      else
        $casegen_script .= "$k $v\n";
    if($casegen_script == '')
      $direct_jump[$seq] = $default;
  }
  
  foreach($pfx as $seq => $choices)
  {
    $level = substr_count($seq, '_');
    if(isset($direct_jump[$seq]))
    {
      #if($level == 0) $input_label = $direct_jump[$seq];
      continue;
    }

    $default = 'DefaultInput';
    $casegen_script = '';
    foreach($choices as $k=>$v)
      if($k == '')
        $default = $v;
      else
      {
        if(isset($direct_jump[$v]))
          $v = $direct_jump[$v];
        $casegen_script .= "$k $v\n";
      }

    $history_test_str .= "\n\n";
    $history_test_str .= "$seq:\n";
    if($casegen_script == '')
    {
      $history_test_str .= "\tjmp $default\n";
    }
    else
    {
      $casegen_script = $default." $counter\n".$casegen_script;
      #for($p=0; $p<256; ++$p)
      #  if(!preg_match("/^$p /m", $casegen_script))
      #    $casegen_script .= "$p $default\n";
      ++$counter;

      $history_test_str .= "\tcall GetHistory$level\n";
      $history_test_str .= RunCaseGen($casegen_script);
    }
  }
  
  while(isset($direct_jump[$input_label]))
    $input_label = $direct_jump[$input_label];

  $input_casegen_script .= "$c $input_label\n";
}

#for($p=0; $p<256; ++$p)
#  if(!preg_match("/^$p /m", $input_casegen_script))
#    $input_casegen_script .= "$p DefaultInput\n";
$input_test_str =
  "\n\nTestInput:\n".
  "\tcall tolower\n".
  RunCaseGen($input_casegen_script);

$history_test_str = preg_replace(
  "/\tcall GetHistory([0-9])\n\tcall BinarySearchLo/",
  "\tcall BinarySearchLoH$1",
  $history_test_str);

print $input_test_str;
print $history_test_str;
print $outcomes_str;

print "\n\n";

print "RedefinedCharMap:\n";
for($c=0; $c<0x20; ++$c)
{
  if(!($c & 0x0F)) print "\tdb "; else print ',';
  $val = 0;
  for($b=0; $b < 8; ++$b)
    if(@$redefinedmap[$c*8+$b])
      $val |= (1 << $b);
  print sprintf('0%02Xh', $val);
  if(!(($c+1) & 0x0F)) print "\n";
}

print "FontData:\n";
for($c=0; $c<0x100; ++$c)
{
  if(@$redefinedmap[$c])
    for($a=$c*16; $a<($c+1)*16; ++$a)
    {
      $x = $a % 16;
      if($x == 0)
        print "\tdb ";
      if($x > 0)
        print ",";
      print sprintf('0%02Xh', ord($ibmfont[$a]));
      if($x == 15)
        print sprintf(" ; %02X %s\n", $c,
          $c>=32 && $c<128 ? "'".chr($c)."'" : '');
    }
}
